/********************************************************
Workspace: IAR+SPL
MCU      : STM8S003k3 (125kHz LSI)
Project  : dimmer with resp
Version  : 0
Date     : Oct, 2017
*********************************************************/
#include "stm8s.h"
#include "iostm003.c"
#include "bitset.c"
#include "stdbool.h"
#include "defines.c"
#include "periph_init.c"
 

extern "C"
{
 INTERRUPT_HANDLER(TIM2_CAPCOM, 14)
 {
  #define adc_pullup PB_ODR_ODR3 = 1
  #define adc_pulldn PB_ODR_ODR3 = 0
  
  static u8 dval=0, aval;
  u16 tmp;
  
  //adc works
  adc_pullup;
  ADC1->CR1 = ADC1_CR1_ADON;
  ADC1->CR1 = ADC1_CR1_ADON;
  //end of adc works
  
  TIM1->EGR = TIM1_EGR_UG; 
  TIM2->EGR = TIM2_EGR_UG;     
  TIM1->CR1 |= TIM1_CR1_CEN; 

  tmp = TIM2->CCR2H<<8; 
  tmp|= TIM2->CCR2L;    
   
  tmp >>= 2;    
  TIM1->ARRH = tmp>>8; 
  TIM1->ARRL = (u8)tmp; 
  
  //adc works   
  aval = ADC1->DRH;
  ADC1->CSR = 0;
  ADC1->CR1 = 0;
  adc_pulldn;    
  //end of adc works  

  if(aval>0xff-0x0f)aval=0xff-1;
  else if (aval<0x0f)aval=1;  
  
  if(dval<aval-1)dval+=2;
  else if(dval-1>aval)dval-=2;
  
  if(dval>0x0f)TIM1->BKR |= TIM1_BKR_MOE;
  else         TIM1->BKR &= ~TIM1_BKR_MOE;
  
  tmp = (u32)tmp*dval/0xff; 
  TIM1->CCR1H = tmp>>8;    
  TIM1->CCR1L = (u8)tmp; 
  if(tmp>1)tmp-=2; 
  else tmp=0;
  TIM1->CCR4H = tmp>>8;    
  TIM1->CCR4L = (u8)tmp;  
  
  PE_ODR^=0xff;
  IWDG_ReloadCounter();
  TIM2->SR1 = 0;
 }
}
void main()
{
 cfg.gpio();
 cfg.clk();
 cfg.t1();
 cfg.t2();
 cfg.iwdg();
 
 asm("rim");
 
 endless asm("wfi");
   
}
